%{

open Parsetree

let check_well_balanced x y =
  if fst x = fst y then () else failwith ("<" ^ (snd x) ^ "> is unmatched")

%}

%token <char> BLANK
%token <Parsetree.tag * string> OTAG
%token <Parsetree.tag * string> CTAG
%token <string> TEXT
%token EOF

%start document
%type <Parsetree.parsetree> document

%%

document:
  elements EOF { $1 }

elements:
  element { [$1] }
| element elements { add $1 $2 }

element:
| TEXT
    { Text $1 }
| OTAG elements CTAG
    { check_well_balanced $1 $3 ;
      Tag (fst $1, snd $1, $2) }
| OTAG CTAG
    { check_well_balanced $1 $2 ;
      Nil }
| BLANK
    { Space $1 }
